<?php
/**
 * AVSApi
 * PHP version 5
 *
 * @category Class
 * @package  Swagger\Client
 * @author   Swagger Codegen team
 * @link     https://github.com/swagger-api/swagger-codegen
 */

/**
 * DOS:\\> Debit Order System API (A Pleasing Interface)
 *
 * Direct Debit are the industry leaders in automated debit order collections in South Africa. We provide debit order systems which assist in the management and automation of your debit order collections. We have created our own payment systems and integrated with popular billing solutions to assist you in invoicing, management of clients and automation of your debit order batches.   **The API can only be accessed or used if you are an account holder.**
 *
 * OpenAPI spec version: 1.1.190200
 * 
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 *
 */

/**
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen
 * Do not edit the class manually.
 */

namespace Swagger\Client\Api;

use \Swagger\Client\ApiClient;
use \Swagger\Client\ApiException;
use \Swagger\Client\Configuration;
use \Swagger\Client\ObjectSerializer;

/**
 * AVSApi Class Doc Comment
 *
 * @category Class
 * @package  Swagger\Client
 * @author   Swagger Codegen team
 * @link     https://github.com/swagger-api/swagger-codegen
 */
class AVSApi
{
    /**
     * API Client
     *
     * @var \Swagger\Client\ApiClient instance of the ApiClient
     */
    protected $apiClient;

    /**
     * Constructor
     *
     * @param \Swagger\Client\ApiClient|null $apiClient The api client to use
     */
    public function __construct(\Swagger\Client\ApiClient $apiClient = null)
    {
        if ($apiClient === null) {
            $apiClient = new ApiClient();
        }

        $this->apiClient = $apiClient;
    }

    /**
     * Get API client
     *
     * @return \Swagger\Client\ApiClient get the API client
     */
    public function getApiClient()
    {
        return $this->apiClient;
    }

    /**
     * Set the API client
     *
     * @param \Swagger\Client\ApiClient $apiClient set the API client
     *
     * @return AVSApi
     */
    public function setApiClient(\Swagger\Client\ApiClient $apiClient)
    {
        $this->apiClient = $apiClient;
        return $this;
    }

    /**
     * Operation avsGetBatchTransactions
     *
     * Retrieve a list of transactions and the state of each transaction.
     *
     * @param int $id Batch &#x60;id&#x60; that needs to be retrieved. (required)
     * @param string $state Return only transactions with a specific state. (optional)
     * @throws \Swagger\Client\ApiException on non-2xx response
     * @return \Swagger\Client\Model\GetAvsTransaction[]
     */
    public function avsGetBatchTransactions($id, $state = null)
    {
        list($response) = $this->avsGetBatchTransactionsWithHttpInfo($id, $state);
        return $response;
    }

    /**
     * Operation avsGetBatchTransactionsWithHttpInfo
     *
     * Retrieve a list of transactions and the state of each transaction.
     *
     * @param int $id Batch &#x60;id&#x60; that needs to be retrieved. (required)
     * @param string $state Return only transactions with a specific state. (optional)
     * @throws \Swagger\Client\ApiException on non-2xx response
     * @return array of \Swagger\Client\Model\GetAvsTransaction[], HTTP status code, HTTP response headers (array of strings)
     */
    public function avsGetBatchTransactionsWithHttpInfo($id, $state = null)
    {
        // verify the required parameter 'id' is set
        if ($id === null) {
            throw new \InvalidArgumentException('Missing the required parameter $id when calling avsGetBatchTransactions');
        }
        // parse inputs
        $resourcePath = "/batch/avs/{id}/transactions";
        $httpBody = '';
        $queryParams = [];
        $headerParams = [];
        $formParams = [];
        $_header_accept = $this->apiClient->selectHeaderAccept(['application/json']);
        if (!is_null($_header_accept)) {
            $headerParams['Accept'] = $_header_accept;
        }
        $headerParams['Content-Type'] = $this->apiClient->selectHeaderContentType([]);

        // query params
        if ($state !== null) {
            $queryParams['state'] = $this->apiClient->getSerializer()->toQueryValue($state);
        }
        // path params
        if ($id !== null) {
            $resourcePath = str_replace(
                "{" . "id" . "}",
                $this->apiClient->getSerializer()->toPathValue($id),
                $resourcePath
            );
        }

        // for model (json/xml)
        if (isset($_tempBody)) {
            $httpBody = $_tempBody; // $_tempBody is the method argument, if present
        } elseif (count($formParams) > 0) {
            $httpBody = $formParams; // for HTTP post (form)
        }
        // this endpoint requires HTTP basic authentication
        if (strlen($this->apiClient->getConfig()->getUsername()) !== 0 or strlen($this->apiClient->getConfig()->getPassword()) !== 0) {
            $headerParams['Authorization'] = 'Basic ' . base64_encode($this->apiClient->getConfig()->getUsername() . ":" . $this->apiClient->getConfig()->getPassword());
        }
        // make the API Call
        try {
            list($response, $statusCode, $httpHeader) = $this->apiClient->callApi(
                $resourcePath,
                'GET',
                $queryParams,
                $httpBody,
                $headerParams,
                '\Swagger\Client\Model\GetAvsTransaction[]',
                '/batch/avs/{id}/transactions'
            );

            return [$this->apiClient->getSerializer()->deserialize($response, '\Swagger\Client\Model\GetAvsTransaction[]', $httpHeader), $statusCode, $httpHeader];
        } catch (ApiException $e) {
            switch ($e->getCode()) {
                case 200:
                    $data = $this->apiClient->getSerializer()->deserialize($e->getResponseBody(), '\Swagger\Client\Model\GetAvsTransaction[]', $e->getResponseHeaders());
                    $e->setResponseObject($data);
                    break;
                case 0:
                    $data = $this->apiClient->getSerializer()->deserialize($e->getResponseBody(), '\Swagger\Client\Model\Error', $e->getResponseHeaders());
                    $e->setResponseObject($data);
                    break;
            }

            throw $e;
        }
    }

    /**
     * Operation avsSubmitBatch
     *
     * Submit a AVS batch to Bankserv.
     *
     * @param int $id Batch &#x60;id&#x60; that needs to be submitted to live system. (required)
     * @throws \Swagger\Client\ApiException on non-2xx response
     * @return \Swagger\Client\Model\BatchSubmitResponse
     */
    public function avsSubmitBatch($id)
    {
        list($response) = $this->avsSubmitBatchWithHttpInfo($id);
        return $response;
    }

    /**
     * Operation avsSubmitBatchWithHttpInfo
     *
     * Submit a AVS batch to Bankserv.
     *
     * @param int $id Batch &#x60;id&#x60; that needs to be submitted to live system. (required)
     * @throws \Swagger\Client\ApiException on non-2xx response
     * @return array of \Swagger\Client\Model\BatchSubmitResponse, HTTP status code, HTTP response headers (array of strings)
     */
    public function avsSubmitBatchWithHttpInfo($id)
    {
        // verify the required parameter 'id' is set
        if ($id === null) {
            throw new \InvalidArgumentException('Missing the required parameter $id when calling avsSubmitBatch');
        }
        // parse inputs
        $resourcePath = "/batch/avs/{id}/submit";
        $httpBody = '';
        $queryParams = [];
        $headerParams = [];
        $formParams = [];
        $_header_accept = $this->apiClient->selectHeaderAccept(['application/json']);
        if (!is_null($_header_accept)) {
            $headerParams['Accept'] = $_header_accept;
        }
        $headerParams['Content-Type'] = $this->apiClient->selectHeaderContentType([]);

        // path params
        if ($id !== null) {
            $resourcePath = str_replace(
                "{" . "id" . "}",
                $this->apiClient->getSerializer()->toPathValue($id),
                $resourcePath
            );
        }

        // for model (json/xml)
        if (isset($_tempBody)) {
            $httpBody = $_tempBody; // $_tempBody is the method argument, if present
        } elseif (count($formParams) > 0) {
            $httpBody = $formParams; // for HTTP post (form)
        }
        // this endpoint requires HTTP basic authentication
        if (strlen($this->apiClient->getConfig()->getUsername()) !== 0 or strlen($this->apiClient->getConfig()->getPassword()) !== 0) {
            $headerParams['Authorization'] = 'Basic ' . base64_encode($this->apiClient->getConfig()->getUsername() . ":" . $this->apiClient->getConfig()->getPassword());
        }
        // make the API Call
        try {
            list($response, $statusCode, $httpHeader) = $this->apiClient->callApi(
                $resourcePath,
                'POST',
                $queryParams,
                $httpBody,
                $headerParams,
                '\Swagger\Client\Model\BatchSubmitResponse',
                '/batch/avs/{id}/submit'
            );

            return [$this->apiClient->getSerializer()->deserialize($response, '\Swagger\Client\Model\BatchSubmitResponse', $httpHeader), $statusCode, $httpHeader];
        } catch (ApiException $e) {
            switch ($e->getCode()) {
                case 200:
                    $data = $this->apiClient->getSerializer()->deserialize($e->getResponseBody(), '\Swagger\Client\Model\BatchSubmitResponse', $e->getResponseHeaders());
                    $e->setResponseObject($data);
                    break;
                case 0:
                    $data = $this->apiClient->getSerializer()->deserialize($e->getResponseBody(), '\Swagger\Client\Model\Error', $e->getResponseHeaders());
                    $e->setResponseObject($data);
                    break;
            }

            throw $e;
        }
    }

    /**
     * Operation avsUploadCsv
     *
     * Upload a AVS CSV batch file containing the transactions to submit to Bankserv.
     *
     * @param \SplFileObject $file_data Upload a correctly formatted CSV file ([download example here](https://dos.directdebit.co.za:31143/static/resources/DD__0001-AVS.csv)) to submit to Bankserv. (required)
     * @param bool $skip_cdv_check Skip CDV verification (Check Digit Verification). (optional)
     * @param bool $skip_checksum Skip checking of duplicate batches. (optional)
     * @param bool $submit_to_bank Set to &#x60;true&#x60; in order to submit transactions automatically to Bankserv. **ONLY VALID** transactions (if &#x60;skip_cdv_check &#x3D; false&#x60;) and **ALL** transactions (if &#x60;skip_cdv_check &#x3D; true&#x60;). (optional)
     * @throws \Swagger\Client\ApiException on non-2xx response
     * @return \Swagger\Client\Model\BatchChecksum
     */
    public function avsUploadCsv($file_data, $skip_cdv_check = null, $skip_checksum = null, $submit_to_bank = null)
    {
        list($response) = $this->avsUploadCsvWithHttpInfo($file_data, $skip_cdv_check, $skip_checksum, $submit_to_bank);
        return $response;
    }

    /**
     * Operation avsUploadCsvWithHttpInfo
     *
     * Upload a AVS CSV batch file containing the transactions to submit to Bankserv.
     *
     * @param \SplFileObject $file_data Upload a correctly formatted CSV file ([download example here](https://dos.directdebit.co.za:31143/static/resources/DD__0001-AVS.csv)) to submit to Bankserv. (required)
     * @param bool $skip_cdv_check Skip CDV verification (Check Digit Verification). (optional)
     * @param bool $skip_checksum Skip checking of duplicate batches. (optional)
     * @param bool $submit_to_bank Set to &#x60;true&#x60; in order to submit transactions automatically to Bankserv. **ONLY VALID** transactions (if &#x60;skip_cdv_check &#x3D; false&#x60;) and **ALL** transactions (if &#x60;skip_cdv_check &#x3D; true&#x60;). (optional)
     * @throws \Swagger\Client\ApiException on non-2xx response
     * @return array of \Swagger\Client\Model\BatchChecksum, HTTP status code, HTTP response headers (array of strings)
     */
    public function avsUploadCsvWithHttpInfo($file_data, $skip_cdv_check = null, $skip_checksum = null, $submit_to_bank = null)
    {
        // verify the required parameter 'file_data' is set
        if ($file_data === null) {
            throw new \InvalidArgumentException('Missing the required parameter $file_data when calling avsUploadCsv');
        }
        // parse inputs
        $resourcePath = "/batch/avs";
        $httpBody = '';
        $queryParams = [];
        $headerParams = [];
        $formParams = [];
        $_header_accept = $this->apiClient->selectHeaderAccept(['application/json']);
        if (!is_null($_header_accept)) {
            $headerParams['Accept'] = $_header_accept;
        }
        $headerParams['Content-Type'] = $this->apiClient->selectHeaderContentType(['multipart/form-data']);

        // query params
        if ($skip_cdv_check !== null) {
            $queryParams['skip_cdv_check'] = $this->apiClient->getSerializer()->toQueryValue($skip_cdv_check);
        }
        // query params
        if ($skip_checksum !== null) {
            $queryParams['skip_checksum'] = $this->apiClient->getSerializer()->toQueryValue($skip_checksum);
        }
        // query params
        if ($submit_to_bank !== null) {
            $queryParams['submit_to_bank'] = $this->apiClient->getSerializer()->toQueryValue($submit_to_bank);
        }
        // form params
        if ($file_data !== null) {
            // PHP 5.5 introduced a CurlFile object that deprecates the old @filename syntax
            // See: https://wiki.php.net/rfc/curl-file-upload
            if (function_exists('curl_file_create')) {
                $formParams['file_data'] = curl_file_create($this->apiClient->getSerializer()->toFormValue($file_data));
            } else {
                $formParams['file_data'] = '@' . $this->apiClient->getSerializer()->toFormValue($file_data);
            }
        }

        // for model (json/xml)
        if (isset($_tempBody)) {
            $httpBody = $_tempBody; // $_tempBody is the method argument, if present
        } elseif (count($formParams) > 0) {
            $httpBody = $formParams; // for HTTP post (form)
        }
        // this endpoint requires HTTP basic authentication
        if (strlen($this->apiClient->getConfig()->getUsername()) !== 0 or strlen($this->apiClient->getConfig()->getPassword()) !== 0) {
            $headerParams['Authorization'] = 'Basic ' . base64_encode($this->apiClient->getConfig()->getUsername() . ":" . $this->apiClient->getConfig()->getPassword());
        }
        // make the API Call
        try {
            list($response, $statusCode, $httpHeader) = $this->apiClient->callApi(
                $resourcePath,
                'POST',
                $queryParams,
                $httpBody,
                $headerParams,
                '\Swagger\Client\Model\BatchChecksum',
                '/batch/avs'
            );

            return [$this->apiClient->getSerializer()->deserialize($response, '\Swagger\Client\Model\BatchChecksum', $httpHeader), $statusCode, $httpHeader];
        } catch (ApiException $e) {
            switch ($e->getCode()) {
                case 200:
                    $data = $this->apiClient->getSerializer()->deserialize($e->getResponseBody(), '\Swagger\Client\Model\BatchChecksum', $e->getResponseHeaders());
                    $e->setResponseObject($data);
                    break;
                case 0:
                    $data = $this->apiClient->getSerializer()->deserialize($e->getResponseBody(), '\Swagger\Client\Model\Error', $e->getResponseHeaders());
                    $e->setResponseObject($data);
                    break;
            }

            throw $e;
        }
    }

    /**
     * Operation avsUploadJson
     *
     * Upload AVS JSON transactions to submit to Bankserv.
     *
     * @param \Swagger\Client\Model\AvsBatchTransaction[] $transactions JSON transactions to be uploaded. (required)
     * @param bool $skip_cdv_check Skip CDV verification (Check Digit Verification). (optional)
     * @param bool $submit_to_bank Set to &#x60;true&#x60; in order to submit transactions automatically to Bankserv. **ONLY VALID** transactions (if &#x60;skip_cdv_check &#x3D; false&#x60;) and **ALL** transactions (if &#x60;skip_cdv_check &#x3D; true&#x60;). (optional)
     * @throws \Swagger\Client\ApiException on non-2xx response
     * @return \Swagger\Client\Model\BatchCount
     */
    public function avsUploadJson($transactions, $skip_cdv_check = null, $submit_to_bank = null)
    {
        list($response) = $this->avsUploadJsonWithHttpInfo($transactions, $skip_cdv_check, $submit_to_bank);
        return $response;
    }

    /**
     * Operation avsUploadJsonWithHttpInfo
     *
     * Upload AVS JSON transactions to submit to Bankserv.
     *
     * @param \Swagger\Client\Model\AvsBatchTransaction[] $transactions JSON transactions to be uploaded. (required)
     * @param bool $skip_cdv_check Skip CDV verification (Check Digit Verification). (optional)
     * @param bool $submit_to_bank Set to &#x60;true&#x60; in order to submit transactions automatically to Bankserv. **ONLY VALID** transactions (if &#x60;skip_cdv_check &#x3D; false&#x60;) and **ALL** transactions (if &#x60;skip_cdv_check &#x3D; true&#x60;). (optional)
     * @throws \Swagger\Client\ApiException on non-2xx response
     * @return array of \Swagger\Client\Model\BatchCount, HTTP status code, HTTP response headers (array of strings)
     */
    public function avsUploadJsonWithHttpInfo($transactions, $skip_cdv_check = null, $submit_to_bank = null)
    {
        // verify the required parameter 'transactions' is set
        if ($transactions === null) {
            throw new \InvalidArgumentException('Missing the required parameter $transactions when calling avsUploadJson');
        }
        // parse inputs
        $resourcePath = "/batch/avs/json";
        $httpBody = '';
        $queryParams = [];
        $headerParams = [];
        $formParams = [];
        $_header_accept = $this->apiClient->selectHeaderAccept(['application/json']);
        if (!is_null($_header_accept)) {
            $headerParams['Accept'] = $_header_accept;
        }
        $headerParams['Content-Type'] = $this->apiClient->selectHeaderContentType(['application/json']);

        // query params
        if ($skip_cdv_check !== null) {
            $queryParams['skip_cdv_check'] = $this->apiClient->getSerializer()->toQueryValue($skip_cdv_check);
        }
        // query params
        if ($submit_to_bank !== null) {
            $queryParams['submit_to_bank'] = $this->apiClient->getSerializer()->toQueryValue($submit_to_bank);
        }
        // body params
        $_tempBody = null;
        if (isset($transactions)) {
            $_tempBody = $transactions;
        }

        // for model (json/xml)
        if (isset($_tempBody)) {
            $httpBody = $_tempBody; // $_tempBody is the method argument, if present
        } elseif (count($formParams) > 0) {
            $httpBody = $formParams; // for HTTP post (form)
        }
        // this endpoint requires HTTP basic authentication
        if (strlen($this->apiClient->getConfig()->getUsername()) !== 0 or strlen($this->apiClient->getConfig()->getPassword()) !== 0) {
            $headerParams['Authorization'] = 'Basic ' . base64_encode($this->apiClient->getConfig()->getUsername() . ":" . $this->apiClient->getConfig()->getPassword());
        }
        // make the API Call
        try {
            list($response, $statusCode, $httpHeader) = $this->apiClient->callApi(
                $resourcePath,
                'POST',
                $queryParams,
                $httpBody,
                $headerParams,
                '\Swagger\Client\Model\BatchCount',
                '/batch/avs/json'
            );

            return [$this->apiClient->getSerializer()->deserialize($response, '\Swagger\Client\Model\BatchCount', $httpHeader), $statusCode, $httpHeader];
        } catch (ApiException $e) {
            switch ($e->getCode()) {
                case 200:
                    $data = $this->apiClient->getSerializer()->deserialize($e->getResponseBody(), '\Swagger\Client\Model\BatchCount', $e->getResponseHeaders());
                    $e->setResponseObject($data);
                    break;
                case 0:
                    $data = $this->apiClient->getSerializer()->deserialize($e->getResponseBody(), '\Swagger\Client\Model\Error', $e->getResponseHeaders());
                    $e->setResponseObject($data);
                    break;
            }

            throw $e;
        }
    }
}
