<?php
/**
 * BatchesApi
 * PHP version 5
 *
 * @category Class
 * @package  Swagger\Client
 * @author   Swagger Codegen team
 * @link     https://github.com/swagger-api/swagger-codegen
 */

/**
 * DOS:\\> Debit Order System API (A Pleasing Interface)
 *
 * Direct Debit are the industry leaders in automated debit order collections in South Africa. We provide debit order systems which assist in the management and automation of your debit order collections. We have created our own payment systems and integrated with popular billing solutions to assist you in invoicing, management of clients and automation of your debit order batches.   **The API can only be accessed or used if you are an account holder.**
 *
 * OpenAPI spec version: 1.1.190200
 * 
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 *
 */

/**
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen
 * Do not edit the class manually.
 */

namespace Swagger\Client\Api;

use \Swagger\Client\ApiClient;
use \Swagger\Client\ApiException;
use \Swagger\Client\Configuration;
use \Swagger\Client\ObjectSerializer;

/**
 * BatchesApi Class Doc Comment
 *
 * @category Class
 * @package  Swagger\Client
 * @author   Swagger Codegen team
 * @link     https://github.com/swagger-api/swagger-codegen
 */
class BatchesApi
{
    /**
     * API Client
     *
     * @var \Swagger\Client\ApiClient instance of the ApiClient
     */
    protected $apiClient;

    /**
     * Constructor
     *
     * @param \Swagger\Client\ApiClient|null $apiClient The api client to use
     */
    public function __construct(\Swagger\Client\ApiClient $apiClient = null)
    {
        if ($apiClient === null) {
            $apiClient = new ApiClient();
        }

        $this->apiClient = $apiClient;
    }

    /**
     * Get API client
     *
     * @return \Swagger\Client\ApiClient get the API client
     */
    public function getApiClient()
    {
        return $this->apiClient;
    }

    /**
     * Set the API client
     *
     * @param \Swagger\Client\ApiClient $apiClient set the API client
     *
     * @return BatchesApi
     */
    public function setApiClient(\Swagger\Client\ApiClient $apiClient)
    {
        $this->apiClient = $apiClient;
        return $this;
    }

    /**
     * Operation deleteBatch
     *
     * Delete a batch and transactions.
     *
     * @param int $id Batch &#x60;id&#x60; to be deleted. (required)
     * @throws \Swagger\Client\ApiException on non-2xx response
     * @return object
     */
    public function deleteBatch($id)
    {
        list($response) = $this->deleteBatchWithHttpInfo($id);
        return $response;
    }

    /**
     * Operation deleteBatchWithHttpInfo
     *
     * Delete a batch and transactions.
     *
     * @param int $id Batch &#x60;id&#x60; to be deleted. (required)
     * @throws \Swagger\Client\ApiException on non-2xx response
     * @return array of object, HTTP status code, HTTP response headers (array of strings)
     */
    public function deleteBatchWithHttpInfo($id)
    {
        // verify the required parameter 'id' is set
        if ($id === null) {
            throw new \InvalidArgumentException('Missing the required parameter $id when calling deleteBatch');
        }
        // parse inputs
        $resourcePath = "/batch/{id}";
        $httpBody = '';
        $queryParams = [];
        $headerParams = [];
        $formParams = [];
        $_header_accept = $this->apiClient->selectHeaderAccept(['application/json']);
        if (!is_null($_header_accept)) {
            $headerParams['Accept'] = $_header_accept;
        }
        $headerParams['Content-Type'] = $this->apiClient->selectHeaderContentType([]);

        // path params
        if ($id !== null) {
            $resourcePath = str_replace(
                "{" . "id" . "}",
                $this->apiClient->getSerializer()->toPathValue($id),
                $resourcePath
            );
        }

        // for model (json/xml)
        if (isset($_tempBody)) {
            $httpBody = $_tempBody; // $_tempBody is the method argument, if present
        } elseif (count($formParams) > 0) {
            $httpBody = $formParams; // for HTTP post (form)
        }
        // this endpoint requires HTTP basic authentication
        if (strlen($this->apiClient->getConfig()->getUsername()) !== 0 or strlen($this->apiClient->getConfig()->getPassword()) !== 0) {
            $headerParams['Authorization'] = 'Basic ' . base64_encode($this->apiClient->getConfig()->getUsername() . ":" . $this->apiClient->getConfig()->getPassword());
        }
        // make the API Call
        try {
            list($response, $statusCode, $httpHeader) = $this->apiClient->callApi(
                $resourcePath,
                'DELETE',
                $queryParams,
                $httpBody,
                $headerParams,
                'object',
                '/batch/{id}'
            );

            return [$this->apiClient->getSerializer()->deserialize($response, 'object', $httpHeader), $statusCode, $httpHeader];
        } catch (ApiException $e) {
            switch ($e->getCode()) {
                case 200:
                    $data = $this->apiClient->getSerializer()->deserialize($e->getResponseBody(), 'object', $e->getResponseHeaders());
                    $e->setResponseObject($data);
                    break;
                case 0:
                    $data = $this->apiClient->getSerializer()->deserialize($e->getResponseBody(), '\Swagger\Client\Model\Error', $e->getResponseHeaders());
                    $e->setResponseObject($data);
                    break;
            }

            throw $e;
        }
    }

    /**
     * Operation getBatch
     *
     * Retrieve the status of a batch file.
     *
     * @param int $id Retrieve the status for the given batch &#x60;id&#x60;. (required)
     * @throws \Swagger\Client\ApiException on non-2xx response
     * @return \Swagger\Client\Model\BatchGet
     */
    public function getBatch($id)
    {
        list($response) = $this->getBatchWithHttpInfo($id);
        return $response;
    }

    /**
     * Operation getBatchWithHttpInfo
     *
     * Retrieve the status of a batch file.
     *
     * @param int $id Retrieve the status for the given batch &#x60;id&#x60;. (required)
     * @throws \Swagger\Client\ApiException on non-2xx response
     * @return array of \Swagger\Client\Model\BatchGet, HTTP status code, HTTP response headers (array of strings)
     */
    public function getBatchWithHttpInfo($id)
    {
        // verify the required parameter 'id' is set
        if ($id === null) {
            throw new \InvalidArgumentException('Missing the required parameter $id when calling getBatch');
        }
        // parse inputs
        $resourcePath = "/batch/{id}";
        $httpBody = '';
        $queryParams = [];
        $headerParams = [];
        $formParams = [];
        $_header_accept = $this->apiClient->selectHeaderAccept(['application/json']);
        if (!is_null($_header_accept)) {
            $headerParams['Accept'] = $_header_accept;
        }
        $headerParams['Content-Type'] = $this->apiClient->selectHeaderContentType([]);

        // path params
        if ($id !== null) {
            $resourcePath = str_replace(
                "{" . "id" . "}",
                $this->apiClient->getSerializer()->toPathValue($id),
                $resourcePath
            );
        }

        // for model (json/xml)
        if (isset($_tempBody)) {
            $httpBody = $_tempBody; // $_tempBody is the method argument, if present
        } elseif (count($formParams) > 0) {
            $httpBody = $formParams; // for HTTP post (form)
        }
        // this endpoint requires HTTP basic authentication
        if (strlen($this->apiClient->getConfig()->getUsername()) !== 0 or strlen($this->apiClient->getConfig()->getPassword()) !== 0) {
            $headerParams['Authorization'] = 'Basic ' . base64_encode($this->apiClient->getConfig()->getUsername() . ":" . $this->apiClient->getConfig()->getPassword());
        }
        // make the API Call
        try {
            list($response, $statusCode, $httpHeader) = $this->apiClient->callApi(
                $resourcePath,
                'GET',
                $queryParams,
                $httpBody,
                $headerParams,
                '\Swagger\Client\Model\BatchGet',
                '/batch/{id}'
            );

            return [$this->apiClient->getSerializer()->deserialize($response, '\Swagger\Client\Model\BatchGet', $httpHeader), $statusCode, $httpHeader];
        } catch (ApiException $e) {
            switch ($e->getCode()) {
                case 200:
                    $data = $this->apiClient->getSerializer()->deserialize($e->getResponseBody(), '\Swagger\Client\Model\BatchGet', $e->getResponseHeaders());
                    $e->setResponseObject($data);
                    break;
                case 0:
                    $data = $this->apiClient->getSerializer()->deserialize($e->getResponseBody(), '\Swagger\Client\Model\Error', $e->getResponseHeaders());
                    $e->setResponseObject($data);
                    break;
            }

            throw $e;
        }
    }

    /**
     * Operation getBatchTransactions
     *
     * Retrieve a list of transactions and the state of each transaction.
     *
     * @param int $id Batch &#x60;id&#x60; that needs to be retrieved. (required)
     * @param string $state Return only transactions with a specific state. (optional)
     * @throws \Swagger\Client\ApiException on non-2xx response
     * @return \Swagger\Client\Model\GetTransaction[]
     */
    public function getBatchTransactions($id, $state = null)
    {
        list($response) = $this->getBatchTransactionsWithHttpInfo($id, $state);
        return $response;
    }

    /**
     * Operation getBatchTransactionsWithHttpInfo
     *
     * Retrieve a list of transactions and the state of each transaction.
     *
     * @param int $id Batch &#x60;id&#x60; that needs to be retrieved. (required)
     * @param string $state Return only transactions with a specific state. (optional)
     * @throws \Swagger\Client\ApiException on non-2xx response
     * @return array of \Swagger\Client\Model\GetTransaction[], HTTP status code, HTTP response headers (array of strings)
     */
    public function getBatchTransactionsWithHttpInfo($id, $state = null)
    {
        // verify the required parameter 'id' is set
        if ($id === null) {
            throw new \InvalidArgumentException('Missing the required parameter $id when calling getBatchTransactions');
        }
        // parse inputs
        $resourcePath = "/batch/{id}/transactions";
        $httpBody = '';
        $queryParams = [];
        $headerParams = [];
        $formParams = [];
        $_header_accept = $this->apiClient->selectHeaderAccept(['application/json']);
        if (!is_null($_header_accept)) {
            $headerParams['Accept'] = $_header_accept;
        }
        $headerParams['Content-Type'] = $this->apiClient->selectHeaderContentType([]);

        // query params
        if ($state !== null) {
            $queryParams['state'] = $this->apiClient->getSerializer()->toQueryValue($state);
        }
        // path params
        if ($id !== null) {
            $resourcePath = str_replace(
                "{" . "id" . "}",
                $this->apiClient->getSerializer()->toPathValue($id),
                $resourcePath
            );
        }

        // for model (json/xml)
        if (isset($_tempBody)) {
            $httpBody = $_tempBody; // $_tempBody is the method argument, if present
        } elseif (count($formParams) > 0) {
            $httpBody = $formParams; // for HTTP post (form)
        }
        // this endpoint requires HTTP basic authentication
        if (strlen($this->apiClient->getConfig()->getUsername()) !== 0 or strlen($this->apiClient->getConfig()->getPassword()) !== 0) {
            $headerParams['Authorization'] = 'Basic ' . base64_encode($this->apiClient->getConfig()->getUsername() . ":" . $this->apiClient->getConfig()->getPassword());
        }
        // make the API Call
        try {
            list($response, $statusCode, $httpHeader) = $this->apiClient->callApi(
                $resourcePath,
                'GET',
                $queryParams,
                $httpBody,
                $headerParams,
                '\Swagger\Client\Model\GetTransaction[]',
                '/batch/{id}/transactions'
            );

            return [$this->apiClient->getSerializer()->deserialize($response, '\Swagger\Client\Model\GetTransaction[]', $httpHeader), $statusCode, $httpHeader];
        } catch (ApiException $e) {
            switch ($e->getCode()) {
                case 200:
                    $data = $this->apiClient->getSerializer()->deserialize($e->getResponseBody(), '\Swagger\Client\Model\GetTransaction[]', $e->getResponseHeaders());
                    $e->setResponseObject($data);
                    break;
                case 0:
                    $data = $this->apiClient->getSerializer()->deserialize($e->getResponseBody(), '\Swagger\Client\Model\Error', $e->getResponseHeaders());
                    $e->setResponseObject($data);
                    break;
            }

            throw $e;
        }
    }

    /**
     * Operation listBatches
     *
     * Retrieve a list of uploaded batches.
     *
     * @param string $from_action_date Search from date \&quot;yyyy-mm-dd\&quot; (date on which the payment becomes effective). (optional)
     * @param string $to_action_date Search to date \&quot;yyyy-mm-dd\&quot; (date on which the payment becomes effective). (optional)
     * @param string $state System only returns batch files with a specific state. (optional)
     * @param string $service_type List only batches of a type eg, &#x60;SAMEDAY&#x60;, &#x60;TWODAY&#x60; or &#x60;NAEDO&#x60;. (optional)
     * @throws \Swagger\Client\ApiException on non-2xx response
     * @return \Swagger\Client\Model\BatchGet[]
     */
    public function listBatches($from_action_date = null, $to_action_date = null, $state = null, $service_type = null)
    {
        list($response) = $this->listBatchesWithHttpInfo($from_action_date, $to_action_date, $state, $service_type);
        return $response;
    }

    /**
     * Operation listBatchesWithHttpInfo
     *
     * Retrieve a list of uploaded batches.
     *
     * @param string $from_action_date Search from date \&quot;yyyy-mm-dd\&quot; (date on which the payment becomes effective). (optional)
     * @param string $to_action_date Search to date \&quot;yyyy-mm-dd\&quot; (date on which the payment becomes effective). (optional)
     * @param string $state System only returns batch files with a specific state. (optional)
     * @param string $service_type List only batches of a type eg, &#x60;SAMEDAY&#x60;, &#x60;TWODAY&#x60; or &#x60;NAEDO&#x60;. (optional)
     * @throws \Swagger\Client\ApiException on non-2xx response
     * @return array of \Swagger\Client\Model\BatchGet[], HTTP status code, HTTP response headers (array of strings)
     */
    public function listBatchesWithHttpInfo($from_action_date = null, $to_action_date = null, $state = null, $service_type = null)
    {
        // parse inputs
        $resourcePath = "/batch";
        $httpBody = '';
        $queryParams = [];
        $headerParams = [];
        $formParams = [];
        $_header_accept = $this->apiClient->selectHeaderAccept(['application/json']);
        if (!is_null($_header_accept)) {
            $headerParams['Accept'] = $_header_accept;
        }
        $headerParams['Content-Type'] = $this->apiClient->selectHeaderContentType([]);

        // query params
        if ($from_action_date !== null) {
            $queryParams['from_action_date'] = $this->apiClient->getSerializer()->toQueryValue($from_action_date);
        }
        // query params
        if ($to_action_date !== null) {
            $queryParams['to_action_date'] = $this->apiClient->getSerializer()->toQueryValue($to_action_date);
        }
        // query params
        if ($state !== null) {
            $queryParams['state'] = $this->apiClient->getSerializer()->toQueryValue($state);
        }
        // query params
        if ($service_type !== null) {
            $queryParams['service_type'] = $this->apiClient->getSerializer()->toQueryValue($service_type);
        }

        // for model (json/xml)
        if (isset($_tempBody)) {
            $httpBody = $_tempBody; // $_tempBody is the method argument, if present
        } elseif (count($formParams) > 0) {
            $httpBody = $formParams; // for HTTP post (form)
        }
        // this endpoint requires HTTP basic authentication
        if (strlen($this->apiClient->getConfig()->getUsername()) !== 0 or strlen($this->apiClient->getConfig()->getPassword()) !== 0) {
            $headerParams['Authorization'] = 'Basic ' . base64_encode($this->apiClient->getConfig()->getUsername() . ":" . $this->apiClient->getConfig()->getPassword());
        }
        // make the API Call
        try {
            list($response, $statusCode, $httpHeader) = $this->apiClient->callApi(
                $resourcePath,
                'GET',
                $queryParams,
                $httpBody,
                $headerParams,
                '\Swagger\Client\Model\BatchGet[]',
                '/batch'
            );

            return [$this->apiClient->getSerializer()->deserialize($response, '\Swagger\Client\Model\BatchGet[]', $httpHeader), $statusCode, $httpHeader];
        } catch (ApiException $e) {
            switch ($e->getCode()) {
                case 200:
                    $data = $this->apiClient->getSerializer()->deserialize($e->getResponseBody(), '\Swagger\Client\Model\BatchGet[]', $e->getResponseHeaders());
                    $e->setResponseObject($data);
                    break;
                case 0:
                    $data = $this->apiClient->getSerializer()->deserialize($e->getResponseBody(), '\Swagger\Client\Model\Error', $e->getResponseHeaders());
                    $e->setResponseObject($data);
                    break;
            }

            throw $e;
        }
    }

    /**
     * Operation replaceCsv
     *
     * Replace an existing batch file.
     *
     * @param int $id Update Batch &#x60;id&#x60;. (required)
     * @param \SplFileObject $file_data Upload a correctly formatted CSV file ([download example here](https://dos.directdebit.co.za:31143/static/resources/directdebit-example-eft-batch.csv)) to submit to Bankserv. (required)
     * @param string $action_date Action date &#x60;yyyy-mm-dd&#x60; (date on which the payment becomes effective). (optional)
     * @param string $nominated_account Nominated account provided in initial service type settings. (optional)
     * @param bool $skip_cdv_check Skip CDV verification (Check Digit Verification). (optional)
     * @param bool $skip_checksum Skip checking of duplicate batches. (optional)
     * @throws \Swagger\Client\ApiException on non-2xx response
     * @return object
     */
    public function replaceCsv($id, $file_data, $action_date = null, $nominated_account = null, $skip_cdv_check = null, $skip_checksum = null)
    {
        list($response) = $this->replaceCsvWithHttpInfo($id, $file_data, $action_date, $nominated_account, $skip_cdv_check, $skip_checksum);
        return $response;
    }

    /**
     * Operation replaceCsvWithHttpInfo
     *
     * Replace an existing batch file.
     *
     * @param int $id Update Batch &#x60;id&#x60;. (required)
     * @param \SplFileObject $file_data Upload a correctly formatted CSV file ([download example here](https://dos.directdebit.co.za:31143/static/resources/directdebit-example-eft-batch.csv)) to submit to Bankserv. (required)
     * @param string $action_date Action date &#x60;yyyy-mm-dd&#x60; (date on which the payment becomes effective). (optional)
     * @param string $nominated_account Nominated account provided in initial service type settings. (optional)
     * @param bool $skip_cdv_check Skip CDV verification (Check Digit Verification). (optional)
     * @param bool $skip_checksum Skip checking of duplicate batches. (optional)
     * @throws \Swagger\Client\ApiException on non-2xx response
     * @return array of object, HTTP status code, HTTP response headers (array of strings)
     */
    public function replaceCsvWithHttpInfo($id, $file_data, $action_date = null, $nominated_account = null, $skip_cdv_check = null, $skip_checksum = null)
    {
        // verify the required parameter 'id' is set
        if ($id === null) {
            throw new \InvalidArgumentException('Missing the required parameter $id when calling replaceCsv');
        }
        // verify the required parameter 'file_data' is set
        if ($file_data === null) {
            throw new \InvalidArgumentException('Missing the required parameter $file_data when calling replaceCsv');
        }
        // parse inputs
        $resourcePath = "/batch/{id}";
        $httpBody = '';
        $queryParams = [];
        $headerParams = [];
        $formParams = [];
        $_header_accept = $this->apiClient->selectHeaderAccept(['application/json']);
        if (!is_null($_header_accept)) {
            $headerParams['Accept'] = $_header_accept;
        }
        $headerParams['Content-Type'] = $this->apiClient->selectHeaderContentType(['multipart/form-data']);

        // query params
        if ($action_date !== null) {
            $queryParams['action_date'] = $this->apiClient->getSerializer()->toQueryValue($action_date);
        }
        // query params
        if ($nominated_account !== null) {
            $queryParams['nominated_account'] = $this->apiClient->getSerializer()->toQueryValue($nominated_account);
        }
        // query params
        if ($skip_cdv_check !== null) {
            $queryParams['skip_cdv_check'] = $this->apiClient->getSerializer()->toQueryValue($skip_cdv_check);
        }
        // query params
        if ($skip_checksum !== null) {
            $queryParams['skip_checksum'] = $this->apiClient->getSerializer()->toQueryValue($skip_checksum);
        }
        // path params
        if ($id !== null) {
            $resourcePath = str_replace(
                "{" . "id" . "}",
                $this->apiClient->getSerializer()->toPathValue($id),
                $resourcePath
            );
        }
        // form params
        if ($file_data !== null) {
            // PHP 5.5 introduced a CurlFile object that deprecates the old @filename syntax
            // See: https://wiki.php.net/rfc/curl-file-upload
            if (function_exists('curl_file_create')) {
                $formParams['file_data'] = curl_file_create($this->apiClient->getSerializer()->toFormValue($file_data));
            } else {
                $formParams['file_data'] = '@' . $this->apiClient->getSerializer()->toFormValue($file_data);
            }
        }

        // for model (json/xml)
        if (isset($_tempBody)) {
            $httpBody = $_tempBody; // $_tempBody is the method argument, if present
        } elseif (count($formParams) > 0) {
            $httpBody = $formParams; // for HTTP post (form)
        }
        // this endpoint requires HTTP basic authentication
        if (strlen($this->apiClient->getConfig()->getUsername()) !== 0 or strlen($this->apiClient->getConfig()->getPassword()) !== 0) {
            $headerParams['Authorization'] = 'Basic ' . base64_encode($this->apiClient->getConfig()->getUsername() . ":" . $this->apiClient->getConfig()->getPassword());
        }
        // make the API Call
        try {
            list($response, $statusCode, $httpHeader) = $this->apiClient->callApi(
                $resourcePath,
                'PUT',
                $queryParams,
                $httpBody,
                $headerParams,
                'object',
                '/batch/{id}'
            );

            return [$this->apiClient->getSerializer()->deserialize($response, 'object', $httpHeader), $statusCode, $httpHeader];
        } catch (ApiException $e) {
            switch ($e->getCode()) {
                case 200:
                    $data = $this->apiClient->getSerializer()->deserialize($e->getResponseBody(), 'object', $e->getResponseHeaders());
                    $e->setResponseObject($data);
                    break;
                case 0:
                    $data = $this->apiClient->getSerializer()->deserialize($e->getResponseBody(), '\Swagger\Client\Model\Error', $e->getResponseHeaders());
                    $e->setResponseObject($data);
                    break;
            }

            throw $e;
        }
    }

    /**
     * Operation replaceJson
     *
     * Replace an existing batch with JSON transactions.
     *
     * @param int $id Update Batch &#x60;id&#x60;. (required)
     * @param \Swagger\Client\Model\BatchTransaction[] $transactions An array of JSON transactions. (required)
     * @param string $action_date Action date should be displayed as follow &#x60;yyyy-mm-dd&#x60;. (optional)
     * @param string $nominated_account Nominated account provided in initial service type settings. (optional)
     * @param bool $skip_cdv_check Skip CDV verification (Check Digit Verification). (optional)
     * @throws \Swagger\Client\ApiException on non-2xx response
     * @return \Swagger\Client\Model\BatchCount
     */
    public function replaceJson($id, $transactions, $action_date = null, $nominated_account = null, $skip_cdv_check = null)
    {
        list($response) = $this->replaceJsonWithHttpInfo($id, $transactions, $action_date, $nominated_account, $skip_cdv_check);
        return $response;
    }

    /**
     * Operation replaceJsonWithHttpInfo
     *
     * Replace an existing batch with JSON transactions.
     *
     * @param int $id Update Batch &#x60;id&#x60;. (required)
     * @param \Swagger\Client\Model\BatchTransaction[] $transactions An array of JSON transactions. (required)
     * @param string $action_date Action date should be displayed as follow &#x60;yyyy-mm-dd&#x60;. (optional)
     * @param string $nominated_account Nominated account provided in initial service type settings. (optional)
     * @param bool $skip_cdv_check Skip CDV verification (Check Digit Verification). (optional)
     * @throws \Swagger\Client\ApiException on non-2xx response
     * @return array of \Swagger\Client\Model\BatchCount, HTTP status code, HTTP response headers (array of strings)
     */
    public function replaceJsonWithHttpInfo($id, $transactions, $action_date = null, $nominated_account = null, $skip_cdv_check = null)
    {
        // verify the required parameter 'id' is set
        if ($id === null) {
            throw new \InvalidArgumentException('Missing the required parameter $id when calling replaceJson');
        }
        // verify the required parameter 'transactions' is set
        if ($transactions === null) {
            throw new \InvalidArgumentException('Missing the required parameter $transactions when calling replaceJson');
        }
        // parse inputs
        $resourcePath = "/batch/{id}/json";
        $httpBody = '';
        $queryParams = [];
        $headerParams = [];
        $formParams = [];
        $_header_accept = $this->apiClient->selectHeaderAccept(['application/json']);
        if (!is_null($_header_accept)) {
            $headerParams['Accept'] = $_header_accept;
        }
        $headerParams['Content-Type'] = $this->apiClient->selectHeaderContentType(['application/json']);

        // query params
        if ($action_date !== null) {
            $queryParams['action_date'] = $this->apiClient->getSerializer()->toQueryValue($action_date);
        }
        // query params
        if ($nominated_account !== null) {
            $queryParams['nominated_account'] = $this->apiClient->getSerializer()->toQueryValue($nominated_account);
        }
        // query params
        if ($skip_cdv_check !== null) {
            $queryParams['skip_cdv_check'] = $this->apiClient->getSerializer()->toQueryValue($skip_cdv_check);
        }
        // path params
        if ($id !== null) {
            $resourcePath = str_replace(
                "{" . "id" . "}",
                $this->apiClient->getSerializer()->toPathValue($id),
                $resourcePath
            );
        }
        // body params
        $_tempBody = null;
        if (isset($transactions)) {
            $_tempBody = $transactions;
        }

        // for model (json/xml)
        if (isset($_tempBody)) {
            $httpBody = $_tempBody; // $_tempBody is the method argument, if present
        } elseif (count($formParams) > 0) {
            $httpBody = $formParams; // for HTTP post (form)
        }
        // this endpoint requires HTTP basic authentication
        if (strlen($this->apiClient->getConfig()->getUsername()) !== 0 or strlen($this->apiClient->getConfig()->getPassword()) !== 0) {
            $headerParams['Authorization'] = 'Basic ' . base64_encode($this->apiClient->getConfig()->getUsername() . ":" . $this->apiClient->getConfig()->getPassword());
        }
        // make the API Call
        try {
            list($response, $statusCode, $httpHeader) = $this->apiClient->callApi(
                $resourcePath,
                'PUT',
                $queryParams,
                $httpBody,
                $headerParams,
                '\Swagger\Client\Model\BatchCount',
                '/batch/{id}/json'
            );

            return [$this->apiClient->getSerializer()->deserialize($response, '\Swagger\Client\Model\BatchCount', $httpHeader), $statusCode, $httpHeader];
        } catch (ApiException $e) {
            switch ($e->getCode()) {
                case 200:
                    $data = $this->apiClient->getSerializer()->deserialize($e->getResponseBody(), '\Swagger\Client\Model\BatchCount', $e->getResponseHeaders());
                    $e->setResponseObject($data);
                    break;
                case 0:
                    $data = $this->apiClient->getSerializer()->deserialize($e->getResponseBody(), '\Swagger\Client\Model\Error', $e->getResponseHeaders());
                    $e->setResponseObject($data);
                    break;
            }

            throw $e;
        }
    }

    /**
     * Operation submitBatch
     *
     * Submit a batch to Bankserv.
     *
     * @param int $id Batch &#x60;id&#x60; that needs to be submitted to live system. (required)
     * @param \Swagger\Client\Model\BatchSubmitBody $data The  &#x60;action_date&#x60; and &#x60;service_type&#x60; will need to be provided. (required)
     * @throws \Swagger\Client\ApiException on non-2xx response
     * @return \Swagger\Client\Model\BatchSubmitResponse
     */
    public function submitBatch($id, $data)
    {
        list($response) = $this->submitBatchWithHttpInfo($id, $data);
        return $response;
    }

    /**
     * Operation submitBatchWithHttpInfo
     *
     * Submit a batch to Bankserv.
     *
     * @param int $id Batch &#x60;id&#x60; that needs to be submitted to live system. (required)
     * @param \Swagger\Client\Model\BatchSubmitBody $data The  &#x60;action_date&#x60; and &#x60;service_type&#x60; will need to be provided. (required)
     * @throws \Swagger\Client\ApiException on non-2xx response
     * @return array of \Swagger\Client\Model\BatchSubmitResponse, HTTP status code, HTTP response headers (array of strings)
     */
    public function submitBatchWithHttpInfo($id, $data)
    {
        // verify the required parameter 'id' is set
        if ($id === null) {
            throw new \InvalidArgumentException('Missing the required parameter $id when calling submitBatch');
        }
        // verify the required parameter 'data' is set
        if ($data === null) {
            throw new \InvalidArgumentException('Missing the required parameter $data when calling submitBatch');
        }
        // parse inputs
        $resourcePath = "/batch/{id}/submit";
        $httpBody = '';
        $queryParams = [];
        $headerParams = [];
        $formParams = [];
        $_header_accept = $this->apiClient->selectHeaderAccept(['application/json']);
        if (!is_null($_header_accept)) {
            $headerParams['Accept'] = $_header_accept;
        }
        $headerParams['Content-Type'] = $this->apiClient->selectHeaderContentType([]);

        // path params
        if ($id !== null) {
            $resourcePath = str_replace(
                "{" . "id" . "}",
                $this->apiClient->getSerializer()->toPathValue($id),
                $resourcePath
            );
        }
        // body params
        $_tempBody = null;
        if (isset($data)) {
            $_tempBody = $data;
        }

        // for model (json/xml)
        if (isset($_tempBody)) {
            $httpBody = $_tempBody; // $_tempBody is the method argument, if present
        } elseif (count($formParams) > 0) {
            $httpBody = $formParams; // for HTTP post (form)
        }
        // this endpoint requires HTTP basic authentication
        if (strlen($this->apiClient->getConfig()->getUsername()) !== 0 or strlen($this->apiClient->getConfig()->getPassword()) !== 0) {
            $headerParams['Authorization'] = 'Basic ' . base64_encode($this->apiClient->getConfig()->getUsername() . ":" . $this->apiClient->getConfig()->getPassword());
        }
        // make the API Call
        try {
            list($response, $statusCode, $httpHeader) = $this->apiClient->callApi(
                $resourcePath,
                'POST',
                $queryParams,
                $httpBody,
                $headerParams,
                '\Swagger\Client\Model\BatchSubmitResponse',
                '/batch/{id}/submit'
            );

            return [$this->apiClient->getSerializer()->deserialize($response, '\Swagger\Client\Model\BatchSubmitResponse', $httpHeader), $statusCode, $httpHeader];
        } catch (ApiException $e) {
            switch ($e->getCode()) {
                case 200:
                    $data = $this->apiClient->getSerializer()->deserialize($e->getResponseBody(), '\Swagger\Client\Model\BatchSubmitResponse', $e->getResponseHeaders());
                    $e->setResponseObject($data);
                    break;
                case 0:
                    $data = $this->apiClient->getSerializer()->deserialize($e->getResponseBody(), '\Swagger\Client\Model\Error', $e->getResponseHeaders());
                    $e->setResponseObject($data);
                    break;
            }

            throw $e;
        }
    }

    /**
     * Operation validateBatch
     *
     * Validate a batch file before submitting to Bankserv.
     *
     * @param int $id Batch &#x60;id&#x60; that needs to be validated. (required)
     * @throws \Swagger\Client\ApiException on non-2xx response
     * @return \Swagger\Client\Model\BatchValidate
     */
    public function validateBatch($id)
    {
        list($response) = $this->validateBatchWithHttpInfo($id);
        return $response;
    }

    /**
     * Operation validateBatchWithHttpInfo
     *
     * Validate a batch file before submitting to Bankserv.
     *
     * @param int $id Batch &#x60;id&#x60; that needs to be validated. (required)
     * @throws \Swagger\Client\ApiException on non-2xx response
     * @return array of \Swagger\Client\Model\BatchValidate, HTTP status code, HTTP response headers (array of strings)
     */
    public function validateBatchWithHttpInfo($id)
    {
        // verify the required parameter 'id' is set
        if ($id === null) {
            throw new \InvalidArgumentException('Missing the required parameter $id when calling validateBatch');
        }
        // parse inputs
        $resourcePath = "/batch/{id}/validate";
        $httpBody = '';
        $queryParams = [];
        $headerParams = [];
        $formParams = [];
        $_header_accept = $this->apiClient->selectHeaderAccept(['application/json']);
        if (!is_null($_header_accept)) {
            $headerParams['Accept'] = $_header_accept;
        }
        $headerParams['Content-Type'] = $this->apiClient->selectHeaderContentType([]);

        // path params
        if ($id !== null) {
            $resourcePath = str_replace(
                "{" . "id" . "}",
                $this->apiClient->getSerializer()->toPathValue($id),
                $resourcePath
            );
        }

        // for model (json/xml)
        if (isset($_tempBody)) {
            $httpBody = $_tempBody; // $_tempBody is the method argument, if present
        } elseif (count($formParams) > 0) {
            $httpBody = $formParams; // for HTTP post (form)
        }
        // this endpoint requires HTTP basic authentication
        if (strlen($this->apiClient->getConfig()->getUsername()) !== 0 or strlen($this->apiClient->getConfig()->getPassword()) !== 0) {
            $headerParams['Authorization'] = 'Basic ' . base64_encode($this->apiClient->getConfig()->getUsername() . ":" . $this->apiClient->getConfig()->getPassword());
        }
        // make the API Call
        try {
            list($response, $statusCode, $httpHeader) = $this->apiClient->callApi(
                $resourcePath,
                'POST',
                $queryParams,
                $httpBody,
                $headerParams,
                '\Swagger\Client\Model\BatchValidate',
                '/batch/{id}/validate'
            );

            return [$this->apiClient->getSerializer()->deserialize($response, '\Swagger\Client\Model\BatchValidate', $httpHeader), $statusCode, $httpHeader];
        } catch (ApiException $e) {
            switch ($e->getCode()) {
                case 200:
                    $data = $this->apiClient->getSerializer()->deserialize($e->getResponseBody(), '\Swagger\Client\Model\BatchValidate', $e->getResponseHeaders());
                    $e->setResponseObject($data);
                    break;
                case 0:
                    $data = $this->apiClient->getSerializer()->deserialize($e->getResponseBody(), '\Swagger\Client\Model\Error', $e->getResponseHeaders());
                    $e->setResponseObject($data);
                    break;
            }

            throw $e;
        }
    }
}
