<?php
/**
 * CDVApi
 * PHP version 5
 *
 * @category Class
 * @package  Swagger\Client
 * @author   Swagger Codegen team
 * @link     https://github.com/swagger-api/swagger-codegen
 */

/**
 * DOS:\\> Debit Order System API (A Pleasing Interface)
 *
 * Direct Debit are the industry leaders in automated debit order collections in South Africa. We provide debit order systems which assist in the management and automation of your debit order collections. We have created our own payment systems and integrated with popular billing solutions to assist you in invoicing, management of clients and automation of your debit order batches.   **The API can only be accessed or used if you are an account holder.**
 *
 * OpenAPI spec version: 1.1.190200
 * 
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 *
 */

/**
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen
 * Do not edit the class manually.
 */

namespace Swagger\Client\Api;

use \Swagger\Client\ApiClient;
use \Swagger\Client\ApiException;
use \Swagger\Client\Configuration;
use \Swagger\Client\ObjectSerializer;

/**
 * CDVApi Class Doc Comment
 *
 * @category Class
 * @package  Swagger\Client
 * @author   Swagger Codegen team
 * @link     https://github.com/swagger-api/swagger-codegen
 */
class CDVApi
{
    /**
     * API Client
     *
     * @var \Swagger\Client\ApiClient instance of the ApiClient
     */
    protected $apiClient;

    /**
     * Constructor
     *
     * @param \Swagger\Client\ApiClient|null $apiClient The api client to use
     */
    public function __construct(\Swagger\Client\ApiClient $apiClient = null)
    {
        if ($apiClient === null) {
            $apiClient = new ApiClient();
        }

        $this->apiClient = $apiClient;
    }

    /**
     * Get API client
     *
     * @return \Swagger\Client\ApiClient get the API client
     */
    public function getApiClient()
    {
        return $this->apiClient;
    }

    /**
     * Set the API client
     *
     * @param \Swagger\Client\ApiClient $apiClient set the API client
     *
     * @return CDVApi
     */
    public function setApiClient(\Swagger\Client\ApiClient $apiClient)
    {
        $this->apiClient = $apiClient;
        return $this;
    }

    /**
     * Operation account
     *
     * Validate a bank account number.
     *
     * @param string $account_number The bank account number provided by the customer. (required)
     * @param string $branch_code The branch code of the specific bank (usually a 6 digit code). (required)
     * @param string $account_type The bank account type (current, savings, transmission or bond). (optional)
     * @throws \Swagger\Client\ApiException on non-2xx response
     * @return \Swagger\Client\Model\AccountCdvCheck
     */
    public function account($account_number, $branch_code, $account_type = null)
    {
        list($response) = $this->accountWithHttpInfo($account_number, $branch_code, $account_type);
        return $response;
    }

    /**
     * Operation accountWithHttpInfo
     *
     * Validate a bank account number.
     *
     * @param string $account_number The bank account number provided by the customer. (required)
     * @param string $branch_code The branch code of the specific bank (usually a 6 digit code). (required)
     * @param string $account_type The bank account type (current, savings, transmission or bond). (optional)
     * @throws \Swagger\Client\ApiException on non-2xx response
     * @return array of \Swagger\Client\Model\AccountCdvCheck, HTTP status code, HTTP response headers (array of strings)
     */
    public function accountWithHttpInfo($account_number, $branch_code, $account_type = null)
    {
        // verify the required parameter 'account_number' is set
        if ($account_number === null) {
            throw new \InvalidArgumentException('Missing the required parameter $account_number when calling account');
        }
        // verify the required parameter 'branch_code' is set
        if ($branch_code === null) {
            throw new \InvalidArgumentException('Missing the required parameter $branch_code when calling account');
        }
        // parse inputs
        $resourcePath = "/cdv/account";
        $httpBody = '';
        $queryParams = [];
        $headerParams = [];
        $formParams = [];
        $_header_accept = $this->apiClient->selectHeaderAccept(['application/json']);
        if (!is_null($_header_accept)) {
            $headerParams['Accept'] = $_header_accept;
        }
        $headerParams['Content-Type'] = $this->apiClient->selectHeaderContentType([]);

        // query params
        if ($account_number !== null) {
            $queryParams['account_number'] = $this->apiClient->getSerializer()->toQueryValue($account_number);
        }
        // query params
        if ($branch_code !== null) {
            $queryParams['branch_code'] = $this->apiClient->getSerializer()->toQueryValue($branch_code);
        }
        // query params
        if ($account_type !== null) {
            $queryParams['account_type'] = $this->apiClient->getSerializer()->toQueryValue($account_type);
        }

        // for model (json/xml)
        if (isset($_tempBody)) {
            $httpBody = $_tempBody; // $_tempBody is the method argument, if present
        } elseif (count($formParams) > 0) {
            $httpBody = $formParams; // for HTTP post (form)
        }
        // this endpoint requires HTTP basic authentication
        if (strlen($this->apiClient->getConfig()->getUsername()) !== 0 or strlen($this->apiClient->getConfig()->getPassword()) !== 0) {
            $headerParams['Authorization'] = 'Basic ' . base64_encode($this->apiClient->getConfig()->getUsername() . ":" . $this->apiClient->getConfig()->getPassword());
        }
        // make the API Call
        try {
            list($response, $statusCode, $httpHeader) = $this->apiClient->callApi(
                $resourcePath,
                'GET',
                $queryParams,
                $httpBody,
                $headerParams,
                '\Swagger\Client\Model\AccountCdvCheck',
                '/cdv/account'
            );

            return [$this->apiClient->getSerializer()->deserialize($response, '\Swagger\Client\Model\AccountCdvCheck', $httpHeader), $statusCode, $httpHeader];
        } catch (ApiException $e) {
            switch ($e->getCode()) {
                case 200:
                    $data = $this->apiClient->getSerializer()->deserialize($e->getResponseBody(), '\Swagger\Client\Model\AccountCdvCheck', $e->getResponseHeaders());
                    $e->setResponseObject($data);
                    break;
                case 0:
                    $data = $this->apiClient->getSerializer()->deserialize($e->getResponseBody(), '\Swagger\Client\Model\Error', $e->getResponseHeaders());
                    $e->setResponseObject($data);
                    break;
            }

            throw $e;
        }
    }

    /**
     * Operation branch
     *
     * Validate a branch code.
     *
     * @param string $branch_code The branch code of the specific bank (usually a 6 digit code). (required)
     * @throws \Swagger\Client\ApiException on non-2xx response
     * @return \Swagger\Client\Model\BranchCdvCheck
     */
    public function branch($branch_code)
    {
        list($response) = $this->branchWithHttpInfo($branch_code);
        return $response;
    }

    /**
     * Operation branchWithHttpInfo
     *
     * Validate a branch code.
     *
     * @param string $branch_code The branch code of the specific bank (usually a 6 digit code). (required)
     * @throws \Swagger\Client\ApiException on non-2xx response
     * @return array of \Swagger\Client\Model\BranchCdvCheck, HTTP status code, HTTP response headers (array of strings)
     */
    public function branchWithHttpInfo($branch_code)
    {
        // verify the required parameter 'branch_code' is set
        if ($branch_code === null) {
            throw new \InvalidArgumentException('Missing the required parameter $branch_code when calling branch');
        }
        // parse inputs
        $resourcePath = "/cdv/branch";
        $httpBody = '';
        $queryParams = [];
        $headerParams = [];
        $formParams = [];
        $_header_accept = $this->apiClient->selectHeaderAccept(['application/json']);
        if (!is_null($_header_accept)) {
            $headerParams['Accept'] = $_header_accept;
        }
        $headerParams['Content-Type'] = $this->apiClient->selectHeaderContentType([]);

        // query params
        if ($branch_code !== null) {
            $queryParams['branch_code'] = $this->apiClient->getSerializer()->toQueryValue($branch_code);
        }

        // for model (json/xml)
        if (isset($_tempBody)) {
            $httpBody = $_tempBody; // $_tempBody is the method argument, if present
        } elseif (count($formParams) > 0) {
            $httpBody = $formParams; // for HTTP post (form)
        }
        // this endpoint requires HTTP basic authentication
        if (strlen($this->apiClient->getConfig()->getUsername()) !== 0 or strlen($this->apiClient->getConfig()->getPassword()) !== 0) {
            $headerParams['Authorization'] = 'Basic ' . base64_encode($this->apiClient->getConfig()->getUsername() . ":" . $this->apiClient->getConfig()->getPassword());
        }
        // make the API Call
        try {
            list($response, $statusCode, $httpHeader) = $this->apiClient->callApi(
                $resourcePath,
                'GET',
                $queryParams,
                $httpBody,
                $headerParams,
                '\Swagger\Client\Model\BranchCdvCheck',
                '/cdv/branch'
            );

            return [$this->apiClient->getSerializer()->deserialize($response, '\Swagger\Client\Model\BranchCdvCheck', $httpHeader), $statusCode, $httpHeader];
        } catch (ApiException $e) {
            switch ($e->getCode()) {
                case 200:
                    $data = $this->apiClient->getSerializer()->deserialize($e->getResponseBody(), '\Swagger\Client\Model\BranchCdvCheck', $e->getResponseHeaders());
                    $e->setResponseObject($data);
                    break;
                case 0:
                    $data = $this->apiClient->getSerializer()->deserialize($e->getResponseBody(), '\Swagger\Client\Model\Error', $e->getResponseHeaders());
                    $e->setResponseObject($data);
                    break;
            }

            throw $e;
        }
    }

    /**
     * Operation validateCdvBatch
     *
     * Upload a CSV batch file containing transactions to validate before submitting.
     *
     * @param \SplFileObject $file_data Upload a correctly formatted CSV file ([download example here](https://dos.directdebit.co.za:31143/static/resources/directdebit-example-eft-batch.csv)) to validate. (required)
     * @throws \Swagger\Client\ApiException on non-2xx response
     * @return \Swagger\Client\Model\CdvTransaction[]
     */
    public function validateCdvBatch($file_data)
    {
        list($response) = $this->validateCdvBatchWithHttpInfo($file_data);
        return $response;
    }

    /**
     * Operation validateCdvBatchWithHttpInfo
     *
     * Upload a CSV batch file containing transactions to validate before submitting.
     *
     * @param \SplFileObject $file_data Upload a correctly formatted CSV file ([download example here](https://dos.directdebit.co.za:31143/static/resources/directdebit-example-eft-batch.csv)) to validate. (required)
     * @throws \Swagger\Client\ApiException on non-2xx response
     * @return array of \Swagger\Client\Model\CdvTransaction[], HTTP status code, HTTP response headers (array of strings)
     */
    public function validateCdvBatchWithHttpInfo($file_data)
    {
        // verify the required parameter 'file_data' is set
        if ($file_data === null) {
            throw new \InvalidArgumentException('Missing the required parameter $file_data when calling validateCdvBatch');
        }
        // parse inputs
        $resourcePath = "/cdv/batch";
        $httpBody = '';
        $queryParams = [];
        $headerParams = [];
        $formParams = [];
        $_header_accept = $this->apiClient->selectHeaderAccept(['application/json']);
        if (!is_null($_header_accept)) {
            $headerParams['Accept'] = $_header_accept;
        }
        $headerParams['Content-Type'] = $this->apiClient->selectHeaderContentType(['multipart/form-data']);

        // form params
        if ($file_data !== null) {
            // PHP 5.5 introduced a CurlFile object that deprecates the old @filename syntax
            // See: https://wiki.php.net/rfc/curl-file-upload
            if (function_exists('curl_file_create')) {
                $formParams['file_data'] = curl_file_create($this->apiClient->getSerializer()->toFormValue($file_data));
            } else {
                $formParams['file_data'] = '@' . $this->apiClient->getSerializer()->toFormValue($file_data);
            }
        }

        // for model (json/xml)
        if (isset($_tempBody)) {
            $httpBody = $_tempBody; // $_tempBody is the method argument, if present
        } elseif (count($formParams) > 0) {
            $httpBody = $formParams; // for HTTP post (form)
        }
        // this endpoint requires HTTP basic authentication
        if (strlen($this->apiClient->getConfig()->getUsername()) !== 0 or strlen($this->apiClient->getConfig()->getPassword()) !== 0) {
            $headerParams['Authorization'] = 'Basic ' . base64_encode($this->apiClient->getConfig()->getUsername() . ":" . $this->apiClient->getConfig()->getPassword());
        }
        // make the API Call
        try {
            list($response, $statusCode, $httpHeader) = $this->apiClient->callApi(
                $resourcePath,
                'POST',
                $queryParams,
                $httpBody,
                $headerParams,
                '\Swagger\Client\Model\CdvTransaction[]',
                '/cdv/batch'
            );

            return [$this->apiClient->getSerializer()->deserialize($response, '\Swagger\Client\Model\CdvTransaction[]', $httpHeader), $statusCode, $httpHeader];
        } catch (ApiException $e) {
            switch ($e->getCode()) {
                case 200:
                    $data = $this->apiClient->getSerializer()->deserialize($e->getResponseBody(), '\Swagger\Client\Model\CdvTransaction[]', $e->getResponseHeaders());
                    $e->setResponseObject($data);
                    break;
                case 0:
                    $data = $this->apiClient->getSerializer()->deserialize($e->getResponseBody(), '\Swagger\Client\Model\Error', $e->getResponseHeaders());
                    $e->setResponseObject($data);
                    break;
            }

            throw $e;
        }
    }
}
