<?php
/**
 * NAEDOBatchesApi
 * PHP version 5
 *
 * @category Class
 * @package  Swagger\Client
 * @author   Swagger Codegen team
 * @link     https://github.com/swagger-api/swagger-codegen
 */

/**
 * DOS:\\> Debit Order System API (A Pleasing Interface)
 *
 * Direct Debit are the industry leaders in automated debit order collections in South Africa. We provide debit order systems which assist in the management and automation of your debit order collections. We have created our own payment systems and integrated with popular billing solutions to assist you in invoicing, management of clients and automation of your debit order batches.   **The API can only be accessed or used if you are an account holder.**
 *
 * OpenAPI spec version: 1.1.190200
 * 
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 *
 */

/**
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen
 * Do not edit the class manually.
 */

namespace Swagger\Client\Api;

use \Swagger\Client\ApiClient;
use \Swagger\Client\ApiException;
use \Swagger\Client\Configuration;
use \Swagger\Client\ObjectSerializer;

/**
 * NAEDOBatchesApi Class Doc Comment
 *
 * @category Class
 * @package  Swagger\Client
 * @author   Swagger Codegen team
 * @link     https://github.com/swagger-api/swagger-codegen
 */
class NAEDOBatchesApi
{
    /**
     * API Client
     *
     * @var \Swagger\Client\ApiClient instance of the ApiClient
     */
    protected $apiClient;

    /**
     * Constructor
     *
     * @param \Swagger\Client\ApiClient|null $apiClient The api client to use
     */
    public function __construct(\Swagger\Client\ApiClient $apiClient = null)
    {
        if ($apiClient === null) {
            $apiClient = new ApiClient();
        }

        $this->apiClient = $apiClient;
    }

    /**
     * Get API client
     *
     * @return \Swagger\Client\ApiClient get the API client
     */
    public function getApiClient()
    {
        return $this->apiClient;
    }

    /**
     * Set the API client
     *
     * @param \Swagger\Client\ApiClient $apiClient set the API client
     *
     * @return NAEDOBatchesApi
     */
    public function setApiClient(\Swagger\Client\ApiClient $apiClient)
    {
        $this->apiClient = $apiClient;
        return $this;
    }

    /**
     * Operation naedoUploadCsv
     *
     * Upload a CSV batch file containing the transactions to submit to Bankserv.
     *
     * @param \SplFileObject $file_data Upload a correctly formatted CSV file ([download example here](https://dos.directdebit.co.za:31143/static/resources/DD__0001-NAEDO.csv)) to submit to Bankserv. (required)
     * @param string $action_date Action date &#x60;yyyy-mm-dd&#x60; (date on which the payment becomes effective). (optional)
     * @param bool $skip_cdv_check Skip CDV verification (Check Digit Verification). (optional)
     * @param bool $skip_checksum Skip checking of duplicate batches. (optional)
     * @param bool $submit_to_bank Set to &#x60;true&#x60; in order to submit transactions automatically to Bankserv. **ONLY VALID** transactions (if &#x60;skip_cdv_check &#x3D; false&#x60;) and **ALL** transactions (if &#x60;skip_cdv_check &#x3D; true&#x60;). (optional)
     * @param int $tracking_days The amount of days an account should be held for representment should the initial payment fail. Tracking day options available are &#x60;0&#x60; to &#x60;10&#x60;, &#x60;14&#x60;, &#x60;21&#x60; or &#x60;31&#x60; days. If tracking days are not set it will use amount of &#x60;tracking_days&#x60; specified in the batch or default to &#x60;0&#x60;. (optional)
     * @throws \Swagger\Client\ApiException on non-2xx response
     * @return \Swagger\Client\Model\BatchChecksum
     */
    public function naedoUploadCsv($file_data, $action_date = null, $skip_cdv_check = null, $skip_checksum = null, $submit_to_bank = null, $tracking_days = null)
    {
        list($response) = $this->naedoUploadCsvWithHttpInfo($file_data, $action_date, $skip_cdv_check, $skip_checksum, $submit_to_bank, $tracking_days);
        return $response;
    }

    /**
     * Operation naedoUploadCsvWithHttpInfo
     *
     * Upload a CSV batch file containing the transactions to submit to Bankserv.
     *
     * @param \SplFileObject $file_data Upload a correctly formatted CSV file ([download example here](https://dos.directdebit.co.za:31143/static/resources/DD__0001-NAEDO.csv)) to submit to Bankserv. (required)
     * @param string $action_date Action date &#x60;yyyy-mm-dd&#x60; (date on which the payment becomes effective). (optional)
     * @param bool $skip_cdv_check Skip CDV verification (Check Digit Verification). (optional)
     * @param bool $skip_checksum Skip checking of duplicate batches. (optional)
     * @param bool $submit_to_bank Set to &#x60;true&#x60; in order to submit transactions automatically to Bankserv. **ONLY VALID** transactions (if &#x60;skip_cdv_check &#x3D; false&#x60;) and **ALL** transactions (if &#x60;skip_cdv_check &#x3D; true&#x60;). (optional)
     * @param int $tracking_days The amount of days an account should be held for representment should the initial payment fail. Tracking day options available are &#x60;0&#x60; to &#x60;10&#x60;, &#x60;14&#x60;, &#x60;21&#x60; or &#x60;31&#x60; days. If tracking days are not set it will use amount of &#x60;tracking_days&#x60; specified in the batch or default to &#x60;0&#x60;. (optional)
     * @throws \Swagger\Client\ApiException on non-2xx response
     * @return array of \Swagger\Client\Model\BatchChecksum, HTTP status code, HTTP response headers (array of strings)
     */
    public function naedoUploadCsvWithHttpInfo($file_data, $action_date = null, $skip_cdv_check = null, $skip_checksum = null, $submit_to_bank = null, $tracking_days = null)
    {
        // verify the required parameter 'file_data' is set
        if ($file_data === null) {
            throw new \InvalidArgumentException('Missing the required parameter $file_data when calling naedoUploadCsv');
        }
        // parse inputs
        $resourcePath = "/batch/naedo";
        $httpBody = '';
        $queryParams = [];
        $headerParams = [];
        $formParams = [];
        $_header_accept = $this->apiClient->selectHeaderAccept(['application/json']);
        if (!is_null($_header_accept)) {
            $headerParams['Accept'] = $_header_accept;
        }
        $headerParams['Content-Type'] = $this->apiClient->selectHeaderContentType(['multipart/form-data']);

        // query params
        if ($action_date !== null) {
            $queryParams['action_date'] = $this->apiClient->getSerializer()->toQueryValue($action_date);
        }
        // query params
        if ($skip_cdv_check !== null) {
            $queryParams['skip_cdv_check'] = $this->apiClient->getSerializer()->toQueryValue($skip_cdv_check);
        }
        // query params
        if ($skip_checksum !== null) {
            $queryParams['skip_checksum'] = $this->apiClient->getSerializer()->toQueryValue($skip_checksum);
        }
        // query params
        if ($submit_to_bank !== null) {
            $queryParams['submit_to_bank'] = $this->apiClient->getSerializer()->toQueryValue($submit_to_bank);
        }
        // query params
        if ($tracking_days !== null) {
            $queryParams['tracking_days'] = $this->apiClient->getSerializer()->toQueryValue($tracking_days);
        }
        // form params
        if ($file_data !== null) {
            // PHP 5.5 introduced a CurlFile object that deprecates the old @filename syntax
            // See: https://wiki.php.net/rfc/curl-file-upload
            if (function_exists('curl_file_create')) {
                $formParams['file_data'] = curl_file_create($this->apiClient->getSerializer()->toFormValue($file_data));
            } else {
                $formParams['file_data'] = '@' . $this->apiClient->getSerializer()->toFormValue($file_data);
            }
        }

        // for model (json/xml)
        if (isset($_tempBody)) {
            $httpBody = $_tempBody; // $_tempBody is the method argument, if present
        } elseif (count($formParams) > 0) {
            $httpBody = $formParams; // for HTTP post (form)
        }
        // this endpoint requires HTTP basic authentication
        if (strlen($this->apiClient->getConfig()->getUsername()) !== 0 or strlen($this->apiClient->getConfig()->getPassword()) !== 0) {
            $headerParams['Authorization'] = 'Basic ' . base64_encode($this->apiClient->getConfig()->getUsername() . ":" . $this->apiClient->getConfig()->getPassword());
        }
        // make the API Call
        try {
            list($response, $statusCode, $httpHeader) = $this->apiClient->callApi(
                $resourcePath,
                'POST',
                $queryParams,
                $httpBody,
                $headerParams,
                '\Swagger\Client\Model\BatchChecksum',
                '/batch/naedo'
            );

            return [$this->apiClient->getSerializer()->deserialize($response, '\Swagger\Client\Model\BatchChecksum', $httpHeader), $statusCode, $httpHeader];
        } catch (ApiException $e) {
            switch ($e->getCode()) {
                case 200:
                    $data = $this->apiClient->getSerializer()->deserialize($e->getResponseBody(), '\Swagger\Client\Model\BatchChecksum', $e->getResponseHeaders());
                    $e->setResponseObject($data);
                    break;
                case 0:
                    $data = $this->apiClient->getSerializer()->deserialize($e->getResponseBody(), '\Swagger\Client\Model\Error', $e->getResponseHeaders());
                    $e->setResponseObject($data);
                    break;
            }

            throw $e;
        }
    }

    /**
     * Operation naedoUploadJson
     *
     * Upload JSON transactions to submit to Bankserv.
     *
     * @param \Swagger\Client\Model\NaedoBatchTransaction[] $transactions JSON transactions to be uploaded. (required)
     * @param string $action_date Action date &#x60;yyyy-mm-dd&#x60; (date on which the payment becomes effective). (optional)
     * @param bool $skip_cdv_check Skip CDV verification (Check Digit Verification). (optional)
     * @param bool $submit_to_bank Set to &#x60;true&#x60; in order to submit transactions automatically to Bankserv. **ONLY VALID** transactions (if &#x60;skip_cdv_check &#x3D; false&#x60;) and **ALL** transactions (if &#x60;skip_cdv_check &#x3D; true&#x60;). (optional)
     * @param int $tracking_days The amount of days an account should be held for representment should the initial payment fail. Tracking day options available are &#x60;0&#x60; to &#x60;10&#x60;, &#x60;14&#x60;, &#x60;21&#x60; or &#x60;31&#x60; days. If tracking days are not set it will use amount of &#x60;tracking_days&#x60; specified in the batch or default to &#x60;0&#x60;. (optional)
     * @throws \Swagger\Client\ApiException on non-2xx response
     * @return \Swagger\Client\Model\BatchCount
     */
    public function naedoUploadJson($transactions, $action_date = null, $skip_cdv_check = null, $submit_to_bank = null, $tracking_days = null)
    {
        list($response) = $this->naedoUploadJsonWithHttpInfo($transactions, $action_date, $skip_cdv_check, $submit_to_bank, $tracking_days);
        return $response;
    }

    /**
     * Operation naedoUploadJsonWithHttpInfo
     *
     * Upload JSON transactions to submit to Bankserv.
     *
     * @param \Swagger\Client\Model\NaedoBatchTransaction[] $transactions JSON transactions to be uploaded. (required)
     * @param string $action_date Action date &#x60;yyyy-mm-dd&#x60; (date on which the payment becomes effective). (optional)
     * @param bool $skip_cdv_check Skip CDV verification (Check Digit Verification). (optional)
     * @param bool $submit_to_bank Set to &#x60;true&#x60; in order to submit transactions automatically to Bankserv. **ONLY VALID** transactions (if &#x60;skip_cdv_check &#x3D; false&#x60;) and **ALL** transactions (if &#x60;skip_cdv_check &#x3D; true&#x60;). (optional)
     * @param int $tracking_days The amount of days an account should be held for representment should the initial payment fail. Tracking day options available are &#x60;0&#x60; to &#x60;10&#x60;, &#x60;14&#x60;, &#x60;21&#x60; or &#x60;31&#x60; days. If tracking days are not set it will use amount of &#x60;tracking_days&#x60; specified in the batch or default to &#x60;0&#x60;. (optional)
     * @throws \Swagger\Client\ApiException on non-2xx response
     * @return array of \Swagger\Client\Model\BatchCount, HTTP status code, HTTP response headers (array of strings)
     */
    public function naedoUploadJsonWithHttpInfo($transactions, $action_date = null, $skip_cdv_check = null, $submit_to_bank = null, $tracking_days = null)
    {
        // verify the required parameter 'transactions' is set
        if ($transactions === null) {
            throw new \InvalidArgumentException('Missing the required parameter $transactions when calling naedoUploadJson');
        }
        // parse inputs
        $resourcePath = "/batch/naedo/json";
        $httpBody = '';
        $queryParams = [];
        $headerParams = [];
        $formParams = [];
        $_header_accept = $this->apiClient->selectHeaderAccept(['application/json']);
        if (!is_null($_header_accept)) {
            $headerParams['Accept'] = $_header_accept;
        }
        $headerParams['Content-Type'] = $this->apiClient->selectHeaderContentType(['application/json']);

        // query params
        if ($action_date !== null) {
            $queryParams['action_date'] = $this->apiClient->getSerializer()->toQueryValue($action_date);
        }
        // query params
        if ($skip_cdv_check !== null) {
            $queryParams['skip_cdv_check'] = $this->apiClient->getSerializer()->toQueryValue($skip_cdv_check);
        }
        // query params
        if ($submit_to_bank !== null) {
            $queryParams['submit_to_bank'] = $this->apiClient->getSerializer()->toQueryValue($submit_to_bank);
        }
        // query params
        if ($tracking_days !== null) {
            $queryParams['tracking_days'] = $this->apiClient->getSerializer()->toQueryValue($tracking_days);
        }
        // body params
        $_tempBody = null;
        if (isset($transactions)) {
            $_tempBody = $transactions;
        }

        // for model (json/xml)
        if (isset($_tempBody)) {
            $httpBody = $_tempBody; // $_tempBody is the method argument, if present
        } elseif (count($formParams) > 0) {
            $httpBody = $formParams; // for HTTP post (form)
        }
        // this endpoint requires HTTP basic authentication
        if (strlen($this->apiClient->getConfig()->getUsername()) !== 0 or strlen($this->apiClient->getConfig()->getPassword()) !== 0) {
            $headerParams['Authorization'] = 'Basic ' . base64_encode($this->apiClient->getConfig()->getUsername() . ":" . $this->apiClient->getConfig()->getPassword());
        }
        // make the API Call
        try {
            list($response, $statusCode, $httpHeader) = $this->apiClient->callApi(
                $resourcePath,
                'POST',
                $queryParams,
                $httpBody,
                $headerParams,
                '\Swagger\Client\Model\BatchCount',
                '/batch/naedo/json'
            );

            return [$this->apiClient->getSerializer()->deserialize($response, '\Swagger\Client\Model\BatchCount', $httpHeader), $statusCode, $httpHeader];
        } catch (ApiException $e) {
            switch ($e->getCode()) {
                case 200:
                    $data = $this->apiClient->getSerializer()->deserialize($e->getResponseBody(), '\Swagger\Client\Model\BatchCount', $e->getResponseHeaders());
                    $e->setResponseObject($data);
                    break;
                case 0:
                    $data = $this->apiClient->getSerializer()->deserialize($e->getResponseBody(), '\Swagger\Client\Model\Error', $e->getResponseHeaders());
                    $e->setResponseObject($data);
                    break;
            }

            throw $e;
        }
    }
}
