<?php
/**
 * ReconApi
 * PHP version 5
 *
 * @category Class
 * @package  Swagger\Client
 * @author   Swagger Codegen team
 * @link     https://github.com/swagger-api/swagger-codegen
 */

/**
 * DOS:\\> Debit Order System API (A Pleasing Interface)
 *
 * Direct Debit are the industry leaders in automated debit order collections in South Africa. We provide debit order systems which assist in the management and automation of your debit order collections. We have created our own payment systems and integrated with popular billing solutions to assist you in invoicing, management of clients and automation of your debit order batches.   **The API can only be accessed or used if you are an account holder.**
 *
 * OpenAPI spec version: 1.1.190200
 * 
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 *
 */

/**
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen
 * Do not edit the class manually.
 */

namespace Swagger\Client\Api;

use \Swagger\Client\ApiClient;
use \Swagger\Client\ApiException;
use \Swagger\Client\Configuration;
use \Swagger\Client\ObjectSerializer;

/**
 * ReconApi Class Doc Comment
 *
 * @category Class
 * @package  Swagger\Client
 * @author   Swagger Codegen team
 * @link     https://github.com/swagger-api/swagger-codegen
 */
class ReconApi
{
    /**
     * API Client
     *
     * @var \Swagger\Client\ApiClient instance of the ApiClient
     */
    protected $apiClient;

    /**
     * Constructor
     *
     * @param \Swagger\Client\ApiClient|null $apiClient The api client to use
     */
    public function __construct(\Swagger\Client\ApiClient $apiClient = null)
    {
        if ($apiClient === null) {
            $apiClient = new ApiClient();
        }

        $this->apiClient = $apiClient;
    }

    /**
     * Get API client
     *
     * @return \Swagger\Client\ApiClient get the API client
     */
    public function getApiClient()
    {
        return $this->apiClient;
    }

    /**
     * Set the API client
     *
     * @param \Swagger\Client\ApiClient $apiClient set the API client
     *
     * @return ReconApi
     */
    public function setApiClient(\Swagger\Client\ApiClient $apiClient)
    {
        $this->apiClient = $apiClient;
        return $this;
    }

    /**
     * Operation getRecon
     *
     * Retrieve reconciliation of transactions processed.
     *
     * @param int $id Recon a specific batch &#x60;id&#x60; only. (optional)
     * @param string $from_action_date Search recon from date \&quot;yyyy-mm-dd\&quot; (action date). (optional)
     * @param string $to_action_date Search recon to date \&quot;yyyy-mm-dd\&quot;(action date). (optional)
     * @param string $from_recon_date Search recon from date \&quot;yyyy-mm-dd\&quot; (recon date). (optional)
     * @param string $to_recon_date Search recon to date \&quot;yyyy-mm-dd\&quot; (recon date). (optional)
     * @param string $state System only returns transactions with a specific state. (optional)
     * @param string $state_code System only returns transactions with a specific state code. (optional)
     * @param string $state_reason System only returns transactions with a specific state reason. (optional)
     * @param string $nominated_account Nominated account provided in your initial service type settings. (optional)
     * @param bool $queue Send the recon response to a queue instead of in the response body. Listen on the queue &#x60;topic&#x60; returned. (optional)
     * @throws \Swagger\Client\ApiException on non-2xx response
     * @return \Swagger\Client\Model\ReconTransaction[]
     */
    public function getRecon($id = null, $from_action_date = null, $to_action_date = null, $from_recon_date = null, $to_recon_date = null, $state = null, $state_code = null, $state_reason = null, $nominated_account = null, $queue = null)
    {
        list($response) = $this->getReconWithHttpInfo($id, $from_action_date, $to_action_date, $from_recon_date, $to_recon_date, $state, $state_code, $state_reason, $nominated_account, $queue);
        return $response;
    }

    /**
     * Operation getReconWithHttpInfo
     *
     * Retrieve reconciliation of transactions processed.
     *
     * @param int $id Recon a specific batch &#x60;id&#x60; only. (optional)
     * @param string $from_action_date Search recon from date \&quot;yyyy-mm-dd\&quot; (action date). (optional)
     * @param string $to_action_date Search recon to date \&quot;yyyy-mm-dd\&quot;(action date). (optional)
     * @param string $from_recon_date Search recon from date \&quot;yyyy-mm-dd\&quot; (recon date). (optional)
     * @param string $to_recon_date Search recon to date \&quot;yyyy-mm-dd\&quot; (recon date). (optional)
     * @param string $state System only returns transactions with a specific state. (optional)
     * @param string $state_code System only returns transactions with a specific state code. (optional)
     * @param string $state_reason System only returns transactions with a specific state reason. (optional)
     * @param string $nominated_account Nominated account provided in your initial service type settings. (optional)
     * @param bool $queue Send the recon response to a queue instead of in the response body. Listen on the queue &#x60;topic&#x60; returned. (optional)
     * @throws \Swagger\Client\ApiException on non-2xx response
     * @return array of \Swagger\Client\Model\ReconTransaction[], HTTP status code, HTTP response headers (array of strings)
     */
    public function getReconWithHttpInfo($id = null, $from_action_date = null, $to_action_date = null, $from_recon_date = null, $to_recon_date = null, $state = null, $state_code = null, $state_reason = null, $nominated_account = null, $queue = null)
    {
        // parse inputs
        $resourcePath = "/recon";
        $httpBody = '';
        $queryParams = [];
        $headerParams = [];
        $formParams = [];
        $_header_accept = $this->apiClient->selectHeaderAccept(['application/json']);
        if (!is_null($_header_accept)) {
            $headerParams['Accept'] = $_header_accept;
        }
        $headerParams['Content-Type'] = $this->apiClient->selectHeaderContentType([]);

        // query params
        if ($id !== null) {
            $queryParams['id'] = $this->apiClient->getSerializer()->toQueryValue($id);
        }
        // query params
        if ($from_action_date !== null) {
            $queryParams['from_action_date'] = $this->apiClient->getSerializer()->toQueryValue($from_action_date);
        }
        // query params
        if ($to_action_date !== null) {
            $queryParams['to_action_date'] = $this->apiClient->getSerializer()->toQueryValue($to_action_date);
        }
        // query params
        if ($from_recon_date !== null) {
            $queryParams['from_recon_date'] = $this->apiClient->getSerializer()->toQueryValue($from_recon_date);
        }
        // query params
        if ($to_recon_date !== null) {
            $queryParams['to_recon_date'] = $this->apiClient->getSerializer()->toQueryValue($to_recon_date);
        }
        // query params
        if ($state !== null) {
            $queryParams['state'] = $this->apiClient->getSerializer()->toQueryValue($state);
        }
        // query params
        if ($state_code !== null) {
            $queryParams['state_code'] = $this->apiClient->getSerializer()->toQueryValue($state_code);
        }
        // query params
        if ($state_reason !== null) {
            $queryParams['state_reason'] = $this->apiClient->getSerializer()->toQueryValue($state_reason);
        }
        // query params
        if ($nominated_account !== null) {
            $queryParams['nominated_account'] = $this->apiClient->getSerializer()->toQueryValue($nominated_account);
        }
        // query params
        if ($queue !== null) {
            $queryParams['queue'] = $this->apiClient->getSerializer()->toQueryValue($queue);
        }

        // for model (json/xml)
        if (isset($_tempBody)) {
            $httpBody = $_tempBody; // $_tempBody is the method argument, if present
        } elseif (count($formParams) > 0) {
            $httpBody = $formParams; // for HTTP post (form)
        }
        // this endpoint requires HTTP basic authentication
        if (strlen($this->apiClient->getConfig()->getUsername()) !== 0 or strlen($this->apiClient->getConfig()->getPassword()) !== 0) {
            $headerParams['Authorization'] = 'Basic ' . base64_encode($this->apiClient->getConfig()->getUsername() . ":" . $this->apiClient->getConfig()->getPassword());
        }
        // make the API Call
        try {
            list($response, $statusCode, $httpHeader) = $this->apiClient->callApi(
                $resourcePath,
                'GET',
                $queryParams,
                $httpBody,
                $headerParams,
                '\Swagger\Client\Model\ReconTransaction[]',
                '/recon'
            );

            return [$this->apiClient->getSerializer()->deserialize($response, '\Swagger\Client\Model\ReconTransaction[]', $httpHeader), $statusCode, $httpHeader];
        } catch (ApiException $e) {
            switch ($e->getCode()) {
                case 200:
                    $data = $this->apiClient->getSerializer()->deserialize($e->getResponseBody(), '\Swagger\Client\Model\ReconTransaction[]', $e->getResponseHeaders());
                    $e->setResponseObject($data);
                    break;
                case 0:
                    $data = $this->apiClient->getSerializer()->deserialize($e->getResponseBody(), '\Swagger\Client\Model\Error', $e->getResponseHeaders());
                    $e->setResponseObject($data);
                    break;
            }

            throw $e;
        }
    }

    /**
     * Operation putReinstate
     *
     * Reinstate a suspended account.
     *
     * @param string $reference The client reference (user reference as specified on mandate). (optional)
     * @param bool $reinstated This is set by default as &#x60;true&#x60;. You can cancel the reinstatement by setting this to &#x60;false&#x60;. (optional)
     * @throws \Swagger\Client\ApiException on non-2xx response
     * @return object
     */
    public function putReinstate($reference = null, $reinstated = null)
    {
        list($response) = $this->putReinstateWithHttpInfo($reference, $reinstated);
        return $response;
    }

    /**
     * Operation putReinstateWithHttpInfo
     *
     * Reinstate a suspended account.
     *
     * @param string $reference The client reference (user reference as specified on mandate). (optional)
     * @param bool $reinstated This is set by default as &#x60;true&#x60;. You can cancel the reinstatement by setting this to &#x60;false&#x60;. (optional)
     * @throws \Swagger\Client\ApiException on non-2xx response
     * @return array of object, HTTP status code, HTTP response headers (array of strings)
     */
    public function putReinstateWithHttpInfo($reference = null, $reinstated = null)
    {
        // parse inputs
        $resourcePath = "/recon/reinstate";
        $httpBody = '';
        $queryParams = [];
        $headerParams = [];
        $formParams = [];
        $_header_accept = $this->apiClient->selectHeaderAccept(['application/json']);
        if (!is_null($_header_accept)) {
            $headerParams['Accept'] = $_header_accept;
        }
        $headerParams['Content-Type'] = $this->apiClient->selectHeaderContentType([]);

        // query params
        if ($reference !== null) {
            $queryParams['reference'] = $this->apiClient->getSerializer()->toQueryValue($reference);
        }
        // query params
        if ($reinstated !== null) {
            $queryParams['reinstated'] = $this->apiClient->getSerializer()->toQueryValue($reinstated);
        }

        // for model (json/xml)
        if (isset($_tempBody)) {
            $httpBody = $_tempBody; // $_tempBody is the method argument, if present
        } elseif (count($formParams) > 0) {
            $httpBody = $formParams; // for HTTP post (form)
        }
        // this endpoint requires HTTP basic authentication
        if (strlen($this->apiClient->getConfig()->getUsername()) !== 0 or strlen($this->apiClient->getConfig()->getPassword()) !== 0) {
            $headerParams['Authorization'] = 'Basic ' . base64_encode($this->apiClient->getConfig()->getUsername() . ":" . $this->apiClient->getConfig()->getPassword());
        }
        // make the API Call
        try {
            list($response, $statusCode, $httpHeader) = $this->apiClient->callApi(
                $resourcePath,
                'PUT',
                $queryParams,
                $httpBody,
                $headerParams,
                'object',
                '/recon/reinstate'
            );

            return [$this->apiClient->getSerializer()->deserialize($response, 'object', $httpHeader), $statusCode, $httpHeader];
        } catch (ApiException $e) {
            switch ($e->getCode()) {
                case 200:
                    $data = $this->apiClient->getSerializer()->deserialize($e->getResponseBody(), 'object', $e->getResponseHeaders());
                    $e->setResponseObject($data);
                    break;
                case 0:
                    $data = $this->apiClient->getSerializer()->deserialize($e->getResponseBody(), '\Swagger\Client\Model\Error', $e->getResponseHeaders());
                    $e->setResponseObject($data);
                    break;
            }

            throw $e;
        }
    }
}
